unit U17nit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TMatchType = (mHorizontal, mVertical);
  TMatch = record
    MatchType: TMatchType;
    X, Y: Integer;
  end;

  TForm1 = class(TForm)
    EditNetHeight: TEdit;
    EditNetWidth: TEdit;
    BtnNewGame: TButton;
    Label1: TLabel;
    Radio1: TRadioButton;
    Radio2: TRadioButton;
    Radio3: TRadioButton;
    NetBox: TPaintBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditName1: TEdit;
    EditName2: TEdit;
    CheckComp1: TCheckBox;
    CheckComp2: TCheckBox;
    LabelScore1: TLabel;
    LabelScore2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BtnNewGameClick(Sender: TObject);
    procedure NetBoxPaint(Sender: TObject);
    procedure NetBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NetBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure DrawNet;
    procedure DrawMatches;
    procedure DrawActive;
    function GetMatchOnPos(X, Y: Integer): TMatch;
    procedure PlaceMatch(Match: TMatch);
    procedure DoLogic;
    procedure UpdateScores;
    procedure SwitchPlayers;
  public
    { Public declarations }
  end;

  TPlayerType = (ptHuman, ptComputer);

  PPlayer = ^TPlayer;
  TPlayer = record
    Name: String;
    Score: Integer;
    PlayerType: TPlayerType;
  end;


var
  Form1: TForm1;

  DefaultNetWidth, DefaultNetHeight: Integer;
  NetWidth, NetHeight: Integer;
  CellWidth, CellHeight: Integer;

  HMatches: array of array of Integer;
  VMatches: array of array of Integer;

  Tiles: array of array of Integer;

  ActiveMatch: TMatch;

  OnMove: PPlayer;

  Player1, Player2: TPlayer;


implementation

{$R *.DFM}

procedure TForm1.DrawNet;
var
  Cik: Integer;
  X1, X2, Y1, Y2: Integer;
  TempPoint: TPoint;

begin
  NetBox.Canvas.Pen.Width := 1;
  NetBox.Canvas.Pen.Color := RGB(0, 0, 0);
  { vertikalni cary }
  Y1 := 0;
  Y2 := NetHeight * CellHeight;
  for Cik := 0 to NetWidth do
  begin
    X1 := Cik * CellWidth;
    X2 := X1;
    TempPoint.x := X1;
    TempPoint.y := Y1;
    NetBox.Canvas.PenPos := TempPoint;
    NetBox.Canvas.LineTo(X2, Y2);
  end;
  { horizontalni cary }
  X1 := 0;
  X2 := NetWidth * CellWidth;
  for Cik := 0 to NetHeight do
  begin
    Y1 := Cik * CellHeight;
    Y2 := Y1;
    TempPoint.x := X1;
    TempPoint.y := Y1;
    NetBox.Canvas.PenPos := TempPoint;
    NetBox.Canvas.LineTo(X2, Y2);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DefaultNetWidth := 10;
  DefaultNetHeight := 10;
  EditNetWidth.Text := IntToStr(DefaultNetWidth);
  EditNetHeight.Text := IntToStr(DefaultNetHeight);

  BtnNewGame.Click;

end;

procedure TForm1.BtnNewGameClick(Sender: TObject);
var
  Code, Cik: Integer;
begin
  { kontrola }
  Val(EditNetWidth.Text, NetWidth, Code);
  if Code <> 0 then
  begin
    EditNetWidth.Text := IntToStr(DefaultNetWidth);
    NetWidth := DefaultNetWidth;
  end;
  Val(EditNetHeight.Text, NetHeight, Code);
  if Code <> 0 then
  begin
    EditNetHeight.Text := IntToStr(DefaultNetHeight);
    NetHeight := DefaultNetHeight;
  end;

  { zmena vlekosti Matches }
  SetLength(HMatches, 0);
  SetLength(VMatches, 0);

  SetLength(HMatches, NetWidth + 1);
  for Cik := 0 to NetWidth do
    SetLength(HMatches[Cik], NetHeight + 1);

  SetLength(VMatches, NetWidth + 1);
  for Cik := 0 to NetWidth do
    SetLength(VMatches[Cik], NetHeight + 1);


  SetLength(Tiles, 0);

  SetLength(Tiles, NetWidth);
  for Cik := 0 to NetWidth -1 do
    SetLength(Tiles[Cik], NetHeight);


  CellWidth := Trunc(NetBox.Width / NetWidth);
  CellHeight := Trunc(NetBox.Height / NetHeight);

  ActiveMatch.MatchType := mHorizontal;
  ActiveMatch.X := 0;
  ActiveMatch.Y := 0;

  Player1.Name := EditName1.Text;
  Player2.Name := EditName2.Text;

  if CheckComp1.Checked then
    Player1.PlayerType := ptComputer
  else
    Player1.PlayerType := ptHuman;

  if CheckComp2.Checked then
    Player2.PlayerType := ptComputer
  else
    Player2.PlayerType := ptHuman;

  if Radio1.Checked then OnMove := @Player1;
  if Radio3.Checked then OnMove := @Player2;
  if Radio2.Checked then
  begin
    Randomize;
    if Round(Random) = 0 then
      OnMove := @Player1
    else
      OnMove := @Player2;
  end;

  NetBox.Invalidate;

end;

procedure TForm1.NetBoxPaint(Sender: TObject);
begin
  DrawNet;
  DrawMatches;
  DrawActive;
end;

procedure TForm1.NetBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   PlaceMatch(GetMatchOnPos(X, Y));
end;

procedure TForm1.DrawMatches;
var
  CikX, CikY: Integer;
  TempPoint: TPoint;
begin
  NetBox.Canvas.Pen.Width := 5;
  for CikX := 0 to NetWidth do    { horiz }
    for CikY := 0 to NetHeight do
    begin
      if HMatches[CikX, CikY] <> 0 then
      begin
        If HMatches[CikX, CikY] = 1 then
          NetBox.Canvas.Pen.Color := RGB(230, 200, 50);
        If HMatches[CikX, CikY] = 2 then
          NetBox.Canvas.Pen.Color := RGB(0, 50, 200);
        If HMatches[CikX, CikY] = 3 then
          NetBox.Canvas.Pen.Color := RGB(200, 50, 0);
        TempPoint.x := (CikX * CellWidth) + NetBox.Canvas.Pen.Width;
        TempPoint.y := CikY * CellHeight;
        NetBox.Canvas.PenPos := TempPoint;
        NetBox.Canvas.LineTo((CikX + 1) * CellWidth - NetBox.Canvas.Pen.Width, CikY * CellHeight);
      end;
    end;

  for CikX := 0 to NetWidth do    { vert }
    for CikY := 0 to NetHeight do
    begin
      if VMatches[CikX, CikY] <> 0 then
      begin
        If VMatches[CikX, CikY] = 1 then
          NetBox.Canvas.Pen.Color := RGB(230, 200, 50);
        If VMatches[CikX, CikY] = 2 then
          NetBox.Canvas.Pen.Color := RGB(0, 50, 200);
        If HMatches[CikX, CikY] = 3 then
          NetBox.Canvas.Pen.Color := RGB(200, 50, 0);
        TempPoint.x := CikX * CellWidth;
        TempPoint.y := CikY * CellHeight + NetBox.Canvas.Pen.Width;
        NetBox.Canvas.PenPos := TempPoint;
        NetBox.Canvas.LineTo(CikX * CellWidth, (CikY + 1) * CellHeight - NetBox.Canvas.Pen.Width);
      end;
    end;


end;

function TForm1.GetMatchOnPos(X, Y: Integer): TMatch;
var
  CellX, CellY: Integer;
  Line: Integer;
  Distance, DistanceX, DistanceY, MinDist: Single;
  PointX, PointY: Integer;
begin
  CellX := X div CellWidth;
  CellY := Y div CellHeight;

  MinDist := High(Integer);
  Line := -1;

  { testujeme vzdalenost on pozice mysi k bodu veprostred vsech ctyr car }
  { nahore vpravo dole vlevo }
  PointX := CellX * CellWidth + (CellWidth div 2);
  PointY := CellY * CellHeight;
  DistanceX := PointX - X;
  DistanceY := PointY - Y;
  Distance := (Sqrt(Sqr(DistanceX) + Sqr(DistanceY)));
  if Distance < MinDist then
  begin
    MinDist := Distance;
    Line := 0;
  end;

  PointX := (CellX + 1) * CellWidth;
  PointY := CellY * CellHeight + (CellHeight div 2);;
  DistanceX := PointX - X;
  DistanceY := PointY - Y;
  Distance := Sqrt(Sqr(DistanceX) + Sqr(DistanceY));
  if Distance < MinDist then
  begin
    MinDist := Distance;
    Line := 1;
  end;

  PointX := CellX * CellWidth + (CellWidth div 2);
  PointY := (CellY + 1) * CellHeight;
  DistanceX := PointX - X;
  DistanceY := PointY - Y;
  Distance := Sqrt(Sqr(DistanceX) + Sqr(DistanceY));
  if Distance < MinDist then
  begin
    MinDist := Distance;
    Line := 2;
  end;

  PointX := CellX * CellWidth;
  PointY := CellY * CellHeight + (CellHeight div 2);;
  DistanceX := PointX - X;
  DistanceY := PointY - Y;
  Distance := Sqrt(Sqr(DistanceX) + Sqr(DistanceY));
  if Distance < MinDist then
  begin
    Line := 3;
  end;

  if Line = 0 then
  begin
    Result.MatchType := mHorizontal;
    Result.X := CellX;
    Result.Y := CellY;
  end;
  if Line = 1 then
  begin
    Result.MatchType := mVertical;
    Result.X := CellX + 1;
    Result.Y := CellY;
  end;

  if Line = 2 then
  begin
    Result.MatchType := mHorizontal;
    Result.X := CellX;
    Result.Y := CellY + 1;
  end;

  if Line = 3 then
  begin
    Result.MatchType := mVertical;
    Result.X := CellX;
    Result.Y := CellY;
  end;
end;

procedure TForm1.NetBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  NewActiveMatch: TMatch;
  TempRect: TRect;
begin
  NewActiveMatch := GetMatchOnPos(X, Y);
  if (NewActiveMatch.MatchType <> ActiveMatch.MatchType) or
     (NewActiveMatch.X <> ActiveMatch.X) or
     (NewActiveMatch.Y <> ActiveMatch.Y) then
     begin
       TempRect.Left := (ActiveMatch.X * CellWidth) - 10;
       TempRect.Right := (ActiveMatch.X + 1 * CellWidth) + 10;
       TempRect.Top := (ActiveMatch.Y * CellWidth) - 10;
       TempRect.Bottom := (ActiveMatch.Y + 1 * CellWidth) - 10;
       TempRect.TopLeft := ScreenToClient(NetBox.ClientToScreen(TempRect.TopLeft));
       TempRect.BottomRight := ScreenToClient(NetBox.ClientToScreen(TempRect.BottomRight));

       ActiveMatch := NewActiveMatch;
{       NetBox.Canvas.brush.Color := NetBox.Color;
       NetBox.Canvas.FillRect(TempRect);
       NetBoxPaint(Self);}
       NetBox.Invalidate;
     end;
end;

procedure TForm1.DrawActive;
var
  TempRect: TRect;
begin
  NetBox.Canvas.Pen.Width := 2;
  NetBox.Canvas.Pen.Color := RGB(100, 20, 0);
  if ActiveMatch.MatchType = mHorizontal then
    TempRect := Rect(ActiveMatch.X * CellWidth, (ActiveMatch.Y * CellHeight) - 3,
      (ActiveMatch.X + 1) * CellWidth, (ActiveMatch.Y) * CellHeight + 3);
  if ActiveMatch.MatchType = mVertical then
    TempRect := Rect(ActiveMatch.X * CellWidth - 3, (ActiveMatch.Y * CellHeight),
      ActiveMatch.X * CellWidth + 3, (ActiveMatch.Y + 1) * CellHeight);


    NetBox.Canvas.brush.Style := bsClear;
    NetBox.Canvas.Rectangle(TempRect);
    NetBox.Canvas.brush.Style := bsSolid;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_LEFT) and (ActiveMatch.X <> 0) then
    if ActiveMatch.MatchType = mHorizontal then
      ActiveMatch.MatchType := mVertical
    else
    begin
      Dec(ActiveMatch.X);
      ActiveMatch.MatchType := mHorizontal
    end;

  if (Key = VK_RIGHT) and (ActiveMatch.X <> NetWidth) then
    if ActiveMatch.MatchType = mVertical then
      ActiveMatch.MatchType := mHorizontal
    else
    begin
      Inc(ActiveMatch.X);
      ActiveMatch.MatchType := mVertical
    end;

  if (Key = VK_UP) and (ActiveMatch.Y <> 0) then
    if ActiveMatch.MatchType = mVertical then
      ActiveMatch.MatchType := mHorizontal
    else
    begin
      Dec(ActiveMatch.Y);
      ActiveMatch.MatchType := mVertical
    end;

  if (Key = VK_DOWN) and (ActiveMatch.Y <> NetHeight) then
    if ActiveMatch.MatchType = mHorizontal then
      ActiveMatch.MatchType := mVertical
    else
    begin
      Inc(ActiveMatch.Y);
      ActiveMatch.MatchType := mHorizontal
    end;

  if (Key = VK_SPACE) or (Key = VK_RETURN) then
    PlaceMatch(ActiveMatch);



  NetBox.Invalidate;
end;

procedure TForm1.PlaceMatch(Match: TMatch);
begin
  if Match.MatchType = mHorizontal then
    if HMatches[Match.X, Match.Y] = 0 then
    begin
      HMatches[Match.X, Match.Y] := 1;
      DoLogic;
    end;
  if Match.MatchType = mVertical then
    if VMatches[Match.X, Match.Y] = 0 then
    begin
      VMatches[Match.X, Match.Y] := 1;
      DoLogic;
    end;


  NetBox.Invalidate;

end;

procedure TForm1.DoLogic;
var
  CikX, CikY: Integer;
begin
  for CikX := 0 to NetWidth - 1 do
    for CikY := 0 to NetHeight - 1 do
    begin
      if Tiles[CikX, CikY] = 0 then
      begin
        if (HMatches[CikX, CikY] = 1) and (VMatches[CikX, CikY] = 1) and
          (VMatches[CikX + 1, CikY] = 1) and (HMatches[CikX, CikY + 1] = 1) then
          begin
            Inc(OnMove.Score);
            Tiles[CikX, CikY] := 1;
            SwitchPlayers;
          end;
      end;
    end;


  UpdateScores;
end;

procedure TForm1.UpdateScores;
begin
  LabelScore1.Caption := Player1.Name + ' ' + IntToStr(Player1.Score);
  LabelScore2.Caption := Player2.Name + ' ' + IntToStr(Player2.Score);
end;

procedure TForm1.SwitchPlayers;
begin
  if OnMove = @Player1 then OnMove := @Player2;
  if OnMove = @Player2 then OnMove := @Player1;  
end;

end.
